<!--
  -  Copyright 2020 Huawei Technologies Co., Ltd.
  -
  -  Licensed under the Apache License, Version 2.0 (the "License");
  -  you may not use this file except in compliance with the License.
  -  You may obtain a copy of the License at
  -
  -      http://www.apache.org/licenses/LICENSE-2.0
  -
  -  Unless required by applicable law or agreed to in writing, software
  -  distributed under the License is distributed on an "AS IS" BASIS,
  -  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -  See the License for the specific language governing permissions and
  -  limitations under the License.
  -->

<template>
  <div>
    <div class="pageTitle">
      <el-row>
        <div class="el-row-button-input">
          <label>
            {{ $t('nav.myres') }}
          </label>
        </div>
      </el-row>
    </div>
    <div class="userList">
      <div class="tableDiv">
        <SearchResource
          :lab-item="true"
          :status-item="true"
          :applicant-item="true"
          @getSearchData="getResourceData"
        />
        <el-row>
          <el-col
            :span="24"
            class="table"
          >
            <el-table
              v-loading="dataLoading"
              :data="currPageTableData"
              border
            >
              <el-table-column
                prop="name"
                :label="$t('env.nameid')"
              />
              <el-table-column
                prop="lab"
                :label="$t('env.lab')"
              />
              <el-table-column
                :label="$t('env.status')"
              >
                <template slot-scope="scope">
                  <span
                    :style="getStatusColor(scope.row.status)"
                  >
                    {{ $t(scope.row.status) }}
                  </span>
                </template>
              </el-table-column>
              <el-table-column
                prop="specifications"
                :label="$t('env.specifications')"
              />
              <el-table-column
                prop="expiredDate"
                :label="$t('env.expiredDate')"
              />
              <el-table-column
                prop="specialResources"
                :label="$t('env.specialResources')"
              />
              <el-table-column
                :label="$t('env.operation')"
                width="220"
              >
                <template slot-scope="scope">
                  <el-button
                    id="editUsrBtn"
                    type="text"
                    size="small"
                    disabled
                  >
                    {{ $t('env.remotelogin') }}
                  </el-button>
                  <el-button
                    id="dltUsrBtn"
                    type="text"
                    size="small"
                    @click="releaseResource(scope.row)"
                  >
                    {{ $t('env.release') }}
                  </el-button>
                  <el-button
                    id="dltUsrBtn"
                    type="text"
                    size="small"
                    disabled
                  >
                    {{ $t('env.resuming') }}
                  </el-button>
                </template>
              </el-table-column>
            </el-table>
          </el-col>
        </el-row>
        <div class="pageBar">
          <Pagination
            :table-data="paginationData"
            @getCurrentPageData="getCurrentPageData"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios'
import { BASE_URL } from '../../tools/constant.js'
import SearchResource from '../../components/SearchResource.vue'
import Pagination from '../../components/Pagination.vue'
export default {
  name: 'CommunityResources',
  components: {
    SearchResource,
    Pagination
  },
  data () {
    return {
      dataLoading: true,
      currentRowData: {},
      resourceList: []
    }
  },
  mounted () {
    this.getResourceData()
  },
  computed: {
  },
  methods: {
    getStatusColor (status) {
      let statusColor = {}
      switch (status) {
        case 'Waiting':
          statusColor = { 'color': '#eeae5a' }
          break
        case 'Rejected':
          statusColor = { 'color': '#e82003' }
          break
        case 'Assigned':
        case 'Approved':
          statusColor = { 'color': '#3fa981' }
          break
      }
      return statusColor
    },
    getCurrentPageData (data) {
      this.currPageTableData = data
    },
    async getResourceData (data) {
      if (!data) {
        data = {
          ipAddress: '',
          lab: 'ALL',
          status: 'ALL',
          requestedBy: ''
        }
      }
      let userId = sessionStorage.getItem('userId')
      let url = `${BASE_URL}/getResource?userId=${userId}&ipAddress=${data.ipAddress}&lab=${data.lab}&status=${data.status}&requestedBy=${data.requestedBy}`
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.paginationData = res.data.resourceData
        this.dataLoading = false
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
          this.dataLoading = false
        }
      })
    },
    releaseResource (data) {
      this.$confirm(this.$t('confirm.confirmToReleaseRes'), this.$t('common.warning'), {
        confirmButtonText: this.$t('common.confirm'),
        cancelButtonText: this.$t('common.cancel'),
        type: 'warning'
      }).then(() => {
        this.releaseResourceConfirm(data)
      })
    },
    releaseResourceConfirm (data) {
      let url = BASE_URL + '/releaseResource?id=' + data.id
      axios({
        method: 'DELETE',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.$parent.successMessage(this.$t('confirm.resReleaseSuccess'))
        this.getResourceData()
      }, error => {
        if (error) {
          this.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    }
  }
}
</script>

<style lang='less' scoped>
.pageTitle {
  margin: 5% 2% 1% 2%;
  font-weight: bold;
}
.userList {
    margin: 0 2%;
    height: 100%;
    background: #fff;
    padding: 30px 0px;
  .tableDiv {
    width: 100%;
  }
  .el-row-button-input {
    margin-top: 10px;
    height:40px;
  }
  .table {
    margin-top: 15px;
  }
  .el-row-table {
    margin-top: 10px;
  }
  .shortdesc{
    overflow: hidden;
    text-overflow: ellipsis;
    display:-webkit-box;
    -webkit-box-orient:vertical;
    -webkit-line-clamp:2;
  }
}
</style>
